Client {
	classvar <>named;
	var <name, <addr;
	var <>password;

	*new { arg name=\default, addr;
		^super.newCopyArgs(name).minit(addr).add
	}
	
	*initClass {
		named = IdentityDictionary.new;
	}
	
	defaultPort { ^57120 } //this is hardcoded in the sources for now
	defaultAddr { ^NetAddr("127.0.0.1", 57120) }
	
	minit { arg argAddr;
		this.addr = argAddr;
	}
	
	add {
		if(named.at(name).notNil, { named.at(name).stop });
		named.put(name, this);
	}

	
	addr_ { arg address;
		addr = if (address.isNil, { 
					this.defaultAddr
				}, { 
					address.port_(this.defaultPort);
				});
	}
	
	
	send { arg ... args;
		addr.sendBundle(nil, ["/client"]++args)
	}
	
	interpret { arg string;
		addr.sendBundle(nil, ["/client", \interpret, password, string]);
	}
	
	recv { arg name, string;
		if(password.isNil, { "set password to allow interpret".inform; ^this });
		this.interpret("ClientFunc.new(" ++ name ++ string ++ ")");
	}
	

}

LocalClient : Client {
	
	classvar <>named, >default;
	var <resp, <isListening=false;
	
	*default { ^default ?? { default = this.new } }
	
	*initClass {
		named = IdentityDictionary.new;
	}
	
	add {
		if(named.at(name).notNil, { named.at(name).stop });
		named.put(name, this);
	}
	
	minit { arg argAddr;
		super.minit(argAddr);
		resp = OSCresponderNode(addr, '/client', { arg time, responder, msg;
			var key, func;
			key = msg[1];
			func = ClientFunc.at(key);
			func.valueArray(msg.drop(2));
		});

	}
	
	defaultAddr { ^nil } // default: listen to all.
	
	start {
		if(isListening.not, { resp.add; isListening = true });
	}
	
	stop {
		resp.remove;
		isListening = false;
	}
	
	// a powerful tool for both good and evil
		
	allowInterpret {
		ClientFunc.new(\interpret, { arg pw, string;
			if(password.notNil and: { pw === password }, { {string.asString.interpret}.defer })
		});
	}
	
	disallow {
		ClientFunc.removeAt(\interpret);
	}
}


ClientFunc {
	var <name, <func;
	
	*new { arg name, func;
		^super.newCopyArgs(name, func).toLib;
	}
	*at { arg key;
		^Library.at(this, key)
	}
	*removeAt { arg key;
		Library.global.removeAt(this, key) //should be in Library
	}
	toLib {
		Library.put(this.class, name.asSymbol, this)
	}
	value { arg ... args; func.valueArray(args) }
	valueArray { arg args; func.valueArray(args) }
	
	
}

